//+------------------------------------------------------------------+
//|                                     One more average heiken ashi |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Orange
#property indicator_color2 LimeGreen
#property indicator_color3 Orange
#property indicator_color4 LimeGreen
#property indicator_width3 2
#property indicator_width4 2

//
//
//
//
//

extern string TimeFrame          = "Current time frame";
extern int    OmaPeriod          = 20;
extern double OmaSpeed           = 3.0;
extern bool   OmaAdaptive        = true;
extern bool   BetterFormula      = true;
extern double Step               = 0;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsNotification = false;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;
extern bool   Interpolate        = true;
//
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trend[];
double stored[][28];

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0, ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, ExtMapBuffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, ExtMapBuffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4, trend);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(timeFrame)+" One more average Heiken Ashi("+OmaPeriod+","+DoubleToStr(OmaSpeed,2)+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
         if (ArrayRange(stored,0) != Bars) ArrayResize(stored,Bars);
         if (Digits==3 || Digits==5)
               double pointModifier = 10;
         else         pointModifier = 1;               
         for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
         {
            double maOpen  = iAverage(Open[i] ,OmaPeriod,OmaSpeed,OmaAdaptive,r, 0);
            double maClose = iAverage(Close[i],OmaPeriod,OmaSpeed,OmaAdaptive,r, 7);
            double maLow   = iAverage(Low[i]  ,OmaPeriod,OmaSpeed,OmaAdaptive,r,14);
            double maHigh  = iAverage(High[i] ,OmaPeriod,OmaSpeed,OmaAdaptive,r,21);
   
            //
            //
            //
            //
            //
        
            if (BetterFormula) {
                  if (maHigh!=maLow)
                        double haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
                  else         haClose = (maOpen+maClose)/2; }
            else               haClose = (maOpen+maHigh+maLow+maClose)/4;
                        double haOpen   = (ExtMapBuffer3[i+1]+ExtMapBuffer4[i+1])/2;
                        double haHigh   = MathMax(maHigh, MathMax(haOpen,haClose));
                        double haLow    = MathMin(maLow,  MathMin(haOpen,haClose));

            if (haOpen<haClose) { ExtMapBuffer1[i]=haLow;  ExtMapBuffer2[i]=haHigh; } 
            else                { ExtMapBuffer1[i]=haHigh; ExtMapBuffer2[i]=haLow;  } 
                                  ExtMapBuffer3[i]=haOpen;
                                  ExtMapBuffer4[i]=haClose;
   
            //
            //
            //
            //
            //
        
            if (Step>0)
            {
               if( MathAbs(ExtMapBuffer1[i]-ExtMapBuffer1[i+1]) < Step*pointModifier*Point ) ExtMapBuffer1[i]=ExtMapBuffer1[i+1];
               if( MathAbs(ExtMapBuffer2[i]-ExtMapBuffer2[i+1]) < Step*pointModifier*Point ) ExtMapBuffer2[i]=ExtMapBuffer2[i+1];
               if( MathAbs(ExtMapBuffer3[i]-ExtMapBuffer3[i+1]) < Step*pointModifier*Point ) ExtMapBuffer3[i]=ExtMapBuffer3[i+1];
               if( MathAbs(ExtMapBuffer4[i]-ExtMapBuffer4[i+1]) < Step*pointModifier*Point ) ExtMapBuffer4[i]=ExtMapBuffer4[i+1];
            }         
            trend[i] = trend[i+1];
               if (ExtMapBuffer1[i]>ExtMapBuffer2[i]) trend[i] = -1;
               if (ExtMapBuffer1[i]<ExtMapBuffer2[i]) trend[i] =  1;
         }  
   
         //
         //
         //
         //
         //
   
         if (alertsOn)
         {
            if (alertsOnCurrent)
                 int whichBar = 0;
            else     whichBar = 1;
            if (trend[whichBar] != trend[whichBar+1])
            if (trend[whichBar] == 1)
                  doAlert("up");
            else  doAlert("down");       
         }
      return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         ExtMapBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",OmaPeriod,OmaSpeed,OmaAdaptive,BetterFormula,Step,alertsOn,alertsOnCurrent,alertsMessage,alertsNotification,alertsSound,alertsEmail,0,y);
         ExtMapBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",OmaPeriod,OmaSpeed,OmaAdaptive,BetterFormula,Step,alertsOn,alertsOnCurrent,alertsMessage,alertsNotification,alertsSound,alertsEmail,1,y);
         ExtMapBuffer3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",OmaPeriod,OmaSpeed,OmaAdaptive,BetterFormula,Step,alertsOn,alertsOnCurrent,alertsMessage,alertsNotification,alertsSound,alertsEmail,2,y);
         ExtMapBuffer4[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",OmaPeriod,OmaSpeed,OmaAdaptive,BetterFormula,Step,alertsOn,alertsOnCurrent,alertsMessage,alertsNotification,alertsSound,alertsEmail,3,y);
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  ExtMapBuffer1[i+k] = ExtMapBuffer1[i] + (ExtMapBuffer1[i+n]-ExtMapBuffer1[i])*k/n;
                  ExtMapBuffer2[i+k] = ExtMapBuffer2[i] + (ExtMapBuffer2[i+n]-ExtMapBuffer2[i])*k/n;
                  ExtMapBuffer3[i+k] = ExtMapBuffer3[i] + (ExtMapBuffer3[i+n]-ExtMapBuffer3[i])*k/n;
                  ExtMapBuffer4[i+k] = ExtMapBuffer4[i] + (ExtMapBuffer4[i+n]-ExtMapBuffer4[i])*k/n;
               }                  
   }               
   return(0);            
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double tconst, bool adaptive, int r, int ashift=0)
{
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+tconst)/(1.0+tconst+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+"OMA HA changed trend to "+doWhat;
             if (alertsMessage)      Alert(message);
             if (alertsNotification) SendNotification(message);
             if (alertsEmail)        SendMail(StringConcatenate(Symbol()," OMA HA"),message);
             if (alertsSound)        PlaySound("alert2.wav");
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}